package tanchinhiong;
import simplerace.*;
import java.util.Random;

/**
 * Created by IntelliJ IDEA.
 * User: jtogel
 * Date: 12-Oct-2006
 * Time: 19:07:59
 * To change this template use File | Settings | File Templates.
 */
public class FieldController5 implements Controller, Evolvable {

    private FieldIndividual field;
    private boolean prevMoveForward = true;
    private int myScore=0;
    private int otherScore=0;

    public FieldController5 () {
        this.field = new FieldIndividual (2);
    }

    private FieldController5 (FieldIndividual input) {
        this.field = input;
    }

    public int control (SensorModel model) {
	double[] parameters = field.getChromosome ();
        
	double k = 0.7858;
	double q_self = 0.5348;
	double q_other = 0.0667;
	double p_other = -0.2416;
	double q_w1 = 2.1337;
	double p_w1 = -0.2098;
	double q_w2 = 0.1506;
	double p_w2 = 0.8972;
        
	double p1 = -0.6251;
	double p2 = -0.5774;
        double p3 = 0;//parameters[1];
        double d1 = 0;//parameters[1];
        double d2 = 0.2;//parameters[1];

        double a = 8.576;
	double b = 11.601;
	double c = 0.272;
	double d = -1.660;
        double p4 = 0.327;
	double e = -Math.PI/2-p4;
	double f = Math.PI/2+p4;
        
        int steering = 1;
	int driving = 1;
	Random random = new Random ();

        double angle;
        double distance;
        if (model.otherVehicleIsPresent()) {
            if(prediction(model)) {
                distance = model.getDistanceToNextWaypoint();
                double basicAngleToOtherVehicle = getBasicAngleToOtherVehicle (model);
                double basicAngleToNextWaypoint = getBasicAngleToNextWaypoint (model);
                double basicAngleToNextNextWaypoint = getBasicAngleToNextNextWaypoint (model);
                double f_other = k * q_self * q_other * Math.pow(model.getDistanceToOtherVehicle (), p_other);
                double f_other_x = f_other * Math.cos(basicAngleToOtherVehicle);
                double f_other_y = f_other * Math.sin(basicAngleToOtherVehicle);
                double f_w1 = k * q_self * q_w1 * Math.pow(model.getDistanceToNextWaypoint (), p_other);
                double f_w1_x = f_w1 * Math.cos(basicAngleToNextWaypoint);
                double f_w1_y = f_w1 * Math.sin(basicAngleToNextWaypoint);
                double f_w2 = k * q_self * q_w2 * Math.pow(model.getDistanceToNextNextWaypoint (), p_other);
                double f_w2_x = f_w2 * Math.cos(basicAngleToNextNextWaypoint);
                double f_w2_y = f_w2 * Math.sin(basicAngleToNextNextWaypoint);
                double final_x = f_other_x + f_w1_x + f_w2_x;
                double final_y = f_other_y + f_w1_y + f_w2_y;
                double final_angle = Math.atan2 (final_y, final_x);
                angle = model.getOrientation () - final_angle;
                angle = Utils.correctAngle (angle);
            }
            else {
                angle = model.getAngleToNextNextWaypoint();
                distance = model.getDistanceToNextNextWaypoint();
            }
        }
        else {
            angle = model.getAngleToNextWaypoint();
            distance = model.getDistanceToNextWaypoint();
        }

        if(model.otherVehicleIsPresent()) {
            if(model.justPassedAWaypoint()) {
//                myScore+=1;
            }
            if(model.otherVehicleJustPassedAWaypoint()) {
//                otherScore+=1;
            }
            if(myScore>otherScore+1.5 && getDistanceOfOtherVehicleToNextWaypoint(model)>0.15) {
                distance -= 0.045;
            }
        }

        double thresholdFunction = a*Math.tanh(b*distance+c)+d;
        if (prevMoveForward) {
            if (thresholdFunction < 0) {
                thresholdFunction = -thresholdFunction;
            }
        }
        else {
            if (thresholdFunction > 0) {
                thresholdFunction = -thresholdFunction;
            }
        }
        if (angle>e && angle<f) {
            if (thresholdFunction < 0) {
                thresholdFunction = -thresholdFunction;
            }
        }
        else {
            if (thresholdFunction > 0) {
                thresholdFunction = -thresholdFunction;
            }
        }
        prevMoveForward = (thresholdFunction > 0) ? true : false;
        
        if (thresholdFunction > 0)
            thresholdFunction = (1+d1)*thresholdFunction;
        if (thresholdFunction < 0)
            thresholdFunction = (1+d2)*thresholdFunction;
        
        double angleLimit = Math.atan2(15+p1,model.getPosition().dist(model.getNextWaypointPosition()));
        if (thresholdFunction > 0 && Math.abs(angle) > angleLimit)
            thresholdFunction = (1+p2)*thresholdFunction;
        if (thresholdFunction < 0 && (Math.PI-Math.abs(angle)) > angleLimit)
            thresholdFunction = (1+p3)*thresholdFunction;
        
        double angleLimitRev = Math.PI-angleLimit;
	if (random.nextDouble () < 0.5) {
            steering = (angle > angleLimit && angle < angleLimitRev) ? 0 : ((angle < -angleLimit && angle > -angleLimitRev) ? 2 : 1);
	    driving = model.getSpeed() > thresholdFunction ? 0 : (model.getSpeed() < thresholdFunction ? 2 : 1);
	}
	else {
            steering = (angle < -angleLimit && angle > -angleLimitRev) ? 2 : ((angle > angleLimit && angle < angleLimitRev) ? 0 : 1);
	    driving = model.getSpeed() < thresholdFunction ? 2 : (model.getSpeed() > thresholdFunction ? 0 : 1);
	}
        if ((int)Math.signum(model.getSpeed()) != (int)Math.signum(thresholdFunction)) {
            steering = 2 - steering;
        }
        
        return driving * 3 + steering;
    }

    public int control (SensorModel model, double[] naviOutput) {
	return 0;
    }

    public void mutate () {
        field.mutate ();
    }

    public void mutate (double rates) {
        field.mutate (rates);
    }

    public void printChromosome () {
	double[] chromosome = getChromosome ();
	for (int i = 0; i < chromosome.length; i++) {
	    System.out.printf("%4f ",chromosome[i]);
	}
	System.out.printf("\n");
    }

    public double[] getChromosome () {
	return field.getChromosome ();
    }

    public void setChromosome (double[] input) {
	field.setChromosome (input);
    }

    public Evolvable copy () {
        return new FieldController5 (field.copy ());
    }

    public void reset () {
        // Not needed here, as we have a reactive controller
    }
    
    public boolean prediction(SensorModel model){
        Vector2d myVectorToNextWaypoint = model.getNextWaypointPosition().copy();
        myVectorToNextWaypoint.subtract(model.getPosition());
        Vector2d myVelocity = model.getVelocity();
        double myVelocityToNextWaypoint = (myVelocity.x * myVectorToNextWaypoint.x + myVelocity.y * myVectorToNextWaypoint.y) / myVectorToNextWaypoint.mag();
        
        Vector2d otherVectorToNextWaypoint = model.getNextWaypointPosition().copy();
        otherVectorToNextWaypoint.subtract(model.getOtherVehiclePosition());
        Vector2d otherVelocity = model.getOtherVehicleVelocity();
        double otherVelocityToNextWaypoint = (otherVelocity.x * otherVectorToNextWaypoint.x + otherVelocity.y * otherVectorToNextWaypoint.y) / otherVectorToNextWaypoint.mag();
        
        if (myVectorToNextWaypoint.mag()<otherVectorToNextWaypoint.mag()) {
            return true;
        }
        else {
            if (myVelocityToNextWaypoint/myVectorToNextWaypoint.mag()>otherVelocityToNextWaypoint/otherVectorToNextWaypoint.mag()) {
                return true;
            }
            else {
                return false;
            }
        }
    }
    
        public double getDistanceOfOtherVehicleToNextWaypoint (SensorModel model) {
            Vector2d nextWp = model.getNextWaypointPosition();
            Vector2d other = model.getOtherVehiclePosition();
            int diagonal = (int) Math.sqrt (400 * 400 * 2);
            return other.dist (nextWp) / diagonal;
        }

        private double getBasicAngleToNextWaypoint (SensorModel model) {
            Vector2d nextWp = model.getNextWaypointPosition();
            Vector2d position = model.getPosition ();
            double xDiff = nextWp.x - position.x;
            double yDiff = nextWp.y - position.y;
            double angle = Math.atan2 (yDiff, xDiff);
	    return angle;
	}

        private double getBasicAngleToNextNextWaypoint (SensorModel model) {
            Vector2d nextNextWp = model.getNextNextWaypointPosition();
            Vector2d position = model.getPosition ();
            double xDiff = nextNextWp.x - position.x;
            double yDiff = nextNextWp.y - position.y;
            double angle = Math.atan2 (yDiff, xDiff);
	    return angle;
        }

        private double getBasicAngleToOtherVehicle (SensorModel model) {
            if (model.otherVehicleIsPresent()) {
                Vector2d otherPosition = model.getOtherVehiclePosition();
                Vector2d thisPosition = model.getPosition();
                double xDiff = otherPosition.x - thisPosition.x;
                double yDiff = otherPosition.y - thisPosition.y;
                double angle = Math.atan2 (yDiff, xDiff);
		return angle;
            }
            else {
                return 0;
            }
        }
}