package tanchinhiong;
import simplerace.*;
import java.util.Random;

public class FieldIndividual {

    private final double mutationMagnitude = 0.1;
    private final double mutationRate = 0.7;
    protected double[] chromosome;

    private final Random random = new Random();

    public FieldIndividual (int length) {
	chromosome = new double[length];
	initialize();
    }

    public FieldIndividual (double[] input) {
	this.chromosome = input;
    }

    public double[] getChromosome () {
	double[] copy = new double[chromosome.length];
        for (int i = 0; i < chromosome.length; i++) {
            copy[i] = chromosome[i];
        }
        return copy;
    }

    public void setChromosome (double[] input) {
        for (int i = 0; i < chromosome.length; i++) {
            chromosome[i] = input[i];
        }
    }

    protected void initialize () {
        for (int i = 0; i < chromosome.length; i++) {
            chromosome[i] = random.nextGaussian();
        }
        /*
//        chromosome[0]+=6;
//        chromosome[1]+=11;
//        chromosome[2]+=-1;
//        chromosome[3]+=0;
        chromosome[4]+=-Math.PI/3;
        chromosome[5]+=Math.PI/3;
        chromosome[6]+=-2*Math.PI/3;
        chromosome[7]+=2*Math.PI/3;
        //*/
    }

    public void mutate () {
	mutate (chromosome, mutationMagnitude);
    }

    public void mutate (double rate) {
	mutate (chromosome, rate);
    }

    protected void mutate (double[] array, double rate) {
        for (int i = 0; i < array.length; i++) {
	    if (random.nextDouble() < mutationRate) {
                array[i] += random.nextGaussian() * rate;
	    }
        }
    }

    public FieldIndividual copy () {
        FieldIndividual fieldcopy = new FieldIndividual(copy(chromosome));
        return fieldcopy;
    }

    protected double[] copy (double[] original) {
        double[] copy = new double[original.length];
        for (int i = 0; i < original.length; i++) {
            copy[i] = original[i];
        }
        return copy;
    }
}